c	This subroutine calculates the current integral and error
c	estimates for the interval given by xl and xr

	SUBROUTINE calc_vals(qprev, xl, xr, rule, n, f, 
     +			     qleft, qright, qnow, error, alpha)

	double precision qprev, xl, xr, f, qright, qleft, qnow, error, xm
	double precision dquad, alpha
	integer n
	external rule, f, dquad

	double precision xm

	xm = 0.5D0*(xl + xr)
	qleft = dquad(rule, n, f, xl, xm)
	qright = dquad(rule, n, f, xm, xr)
	qnow = qleft + qright
	error = qnow-qprev

	return
	end
