      DOUBLE PRECISION A,B,TOL,APPROX,ERREST,F,DAQUAD
      EXTERNAL F,DGLEGQ

C     LOOP
 10   CONTINUE

         WRITE (6,1) ' TYPE A,B,TOL TO INTEGRATE',
     +               ' OR 0 0 0 TO TERMINATE:'
 1       FORMAT(/// 2A )
         READ (5,*) A,B,TOL

         IF (A .EQ. 0.D0 .AND. B .EQ. 0.D0 .AND. TOL .EQ. 0.D0) STOP
   
         WRITE (6,2) ' A = ', A, '   B = ', B, '   TOL = ', TOL
 2       FORMAT ( /// 3(A,1PD15.5))

         MAXLEV = 30
   
         APPROX = DAQUAD(DGLEGQ,2,F,A,B,TOL,MAXLEV,ERREST)
   
         IF (TOL .NE. 0.D0) WRITE (6,*) 'ROUTINE FAILED. TOL = ',TOL,
     +                                  '  SING = ',SING
   
         WRITE (6,3) ' APPROXIMATE VALUE OF INTEGRAL = ',APPROX,
     +               ' ERROR ESTIMATE = ',ERREST,
     +               ' # SUBINTERVALS USED = ',MAXLEV,
     +               ' TRUE VALUE OF INTEGRAL = ',EXP(B) - EXP(A),
     +               ' TRUE ERROR = ',(EXP(B) - EXP(A)) - APPROX
 3       FORMAT ( A,1PD15.5 / A,1PD15.5 / A,I5, 2(/A,1PD15.5) )

      GOTO 10
C     END LOOP

      END



      DOUBLE PRECISION FUNCTION F(X)
      DOUBLE PRECISION X
     
      F = EXP(X)
	
      RETURN
      END
