c	PROGRAM heap
c	
c	integer heap(0:1000)
c	double precision left(1000), right(1000), value(1000), 
c     +			 error(1000), lval(1000), rval(1000)
c	double precision l, r, val, err, qleft, qright
c	integer pos
c
c
c	heap(0)=0
c
c 1
c	l=1.0
c	val=50.0
c	call insert(l, l, val, val, 1.0d0, 2.0d0, heap, 
c     +			left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c 2
c	call insert(1.0d0, 2.0d0, 50.0d0, 0.1d0, 3.0d0, 4.0d0, heap, 
c     +			left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c 3
c	call insert(3.0d0, 4.0d0, 50.0d0, 0.8d0, 5.0d0, 6.0d0, heap, 
c     +			left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c 4
c	call insert(6.0d0, 5.0d0, 50.0d0, 0.4d0, 7.0d0, 8.0d0, heap, 
c     +			left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c 3
c	call remove(l, r, val, err, qleft, qright, heap, 
c     +  		left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c 2
c	call remove(l, r, val, err, qleft, qright, heap, 
c     +  		left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c 2
c	call remove_top(l, r, val, err, qleft, qright, heap, 
c     +  		left, right, value, error, lval, rval, pos)
c	call insert_top(4.0d0, 5.0d0, 1.0d0, 3.0d0, 0.1d0, 0.2d0,heap, 
c     +  		left, right, value, error, lval, rval, pos)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c 1
c	call remove(l, r, val, err, qleft, qright, heap, 
c     +  		left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
cc 0
c	call remove(l, r, val, err, qleft, qright, heap, 
c     +  		left, right, value, error, lval, rval)
c	call prnt(heap, left, right, value, error, lval, rval)
c
c	stop
c	end
c

	SUBROUTINE prnt(heap, left, right, value, error, lval, rval)
	double precision left(1000), right(1000), value(1000), 
     +			 error(1000), lval(1000), rval(1000)
	integer heap(0:1000)

	integer i

	print *, heap(0)

	do 50 i=1, heap(0), 1
	   print *, left(heap(i)), right(heap(i)), value(heap(i)),
     + error(heap(i)), lval(heap(i)), rval(heap(i))
50	continue

	return
	end


	SUBROUTINE insert_top(l, r, val, err, qleft, qright, heap, 
     +			  left, right, value, error, lval, rval, pos)
	double precision l, r, val, err, qleft, qright

	double precision left(1000), right(1000), value(1000), 
     +			 error(1000), lval(1000), rval(1000)
	integer heap(0:1000), pos

	integer temp

c	print *, "hello", pos

	left(pos)=l
	right(pos)=r
	value(pos)=val
	error(pos)=err
	lval(pos)=qleft
	rval(pos)=qright
	heap(1)=pos

	temp=1
	call reheap_down(temp, heap, error)

	return
	end


	SUBROUTINE insert(l, r, val, err, qleft, qright, heap, 
     +			  left, right, value, error, lval, rval)
	double precision l, r, val, err, qleft, qright
	double precision left(1000), right(1000), value(1000), 
     +			 error(1000), lval(1000), rval(1000)
	integer heap(0:1000)

	integer temp

	heap(0)=heap(0)+1
	left(heap(0))=l
	right(heap(0))=r
	value(heap(0))=val
	error(heap(0))=err
	lval(heap(0))=qleft
	rval(heap(0))=qright
	heap(heap(0))=heap(0)

	temp=heap(0)
	call reheap_up(temp, heap, error)
	
	return
	end


	SUBROUTINE remove_top(l, r, val, err, qleft, qright, heap,
     +			  left, right, value, error, lval, rval, pos)

	double precision l, r, val, err, qleft, qright
	double precision left(1000), right(1000), value(1000), 
     +			 error(1000), lval(1000), rval(1000)
	integer heap(0:1000), pos

	l=left(heap(1))
	r=right(heap(1))
	val=value(heap(1))
	err=error(heap(1))
	qleft=lval(heap(1))
	qright=rval(heap(1))
	pos=heap(1)

	return
	end


	SUBROUTINE remove(l, r, val, err, qleft, qright, heap,
     +			  left, right, value, error, lval, rval)

	double precision l, r, val, err, qleft, qright
	double precision left(1000), right(1000), value(1000), 
     +			 error(1000), lval(1000), rval(1000)
	integer heap(0:1000)

	integer current

	l=left(heap(1))
	r=right(heap(1))
	val=value(heap(1))
	err=error(heap(1))
	qleft=lval(heap(1))
	qright=rval(heap(1))

	left(heap(1))=left(heap(0))
	right(heap(1))=right(heap(0))
	value(heap(1))=value(heap(0))
	error(heap(1))=error(heap(0))
	lval(heap(1))=lval(heap(0))
	rval(heap(1))=rval(heap(0))

	current=2
95	if (heap(current) .eq. heap(0)) then
	  goto 100
	endif

	current=current+1
	goto 95

100	heap(current)=heap(0)
	heap(1)=heap(heap(0))

	heap(0)=heap(0)-1

	call reheap_down(1, heap, error)

	return
	end


	SUBROUTINE reheap_up(curr, heap, error)
	integer heap(0:1000), curr
	double precision error(1000)

	integer parent, swap, current

	current=curr
	parent=current/2


130	if (parent .eq. 0 .or.
     +	    dabs(error(heap(current))) .le. dabs(error(heap(parent)))) 
     +      then
	  goto 140
	endif

	   swap=heap(current)
	   heap(current)=heap(parent)
	   heap(parent)=swap

	   current=parent
	   parent=current/2
	   goto 130

140 	continue

	return
	end



	SUBROUTINE reheap_down(curr, heap, error)
	integer curr, heap(0:1000)
	double precision error(1000)

	integer child, swap, current

	current=curr

150	if (current*2 .gt. heap(0)) then
	   return
	endif

	child=current*2
	if (child+1 .le. heap(0)) then
	   if(dabs(error(heap(child+1))) .gt. dabs(error(heap(child))))
     +	   then
	      child=child+1
	   endif
	endif

	if (dabs(error(heap(child))) .le. dabs(error(heap(current)))) then
	   goto 170
	endif

	swap=heap(current)
	heap(current)=heap(child)
	heap(child)=swap

	current=child

	goto 150

170	continue

	return
	end
